#include "config.h"
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <badpenguin-ansi.h>
#include <badpenguin-chain.h>
#include <badpenguin-fs.h>
#include <badpenguin-hardware.h>

#define   USES_NCURSES
#include <gringo.h>

#include "caronte.h"
#include "caronte-init.h"
#include "caronte-logo.h"
#include "caronte-distribution.h"

TGrid   *grid1 = NULL;
TChainItem *pitem=NULL;
TPartition *ppart=NULL;

void SelectDistro() {
  char *devname;

  // Get devicename  
  if ( grid1->firstCol->activeItem==NULL) {
    beep();
    return;
  }
  if (grid1->firstCol->activeItem->text==NULL) {
    beep();
    return;
  }
  devname =  grid1->firstCol->activeItem->text;

  // Find the right one
  for ( pitem=distro->head; pitem!=NULL; pitem=pitem->next) {
    ppart = TPARTITION(pitem->data);
    if (0 == strcasecmp(ppart->device, devname) ) {
      sourcedist=ppart;
      gringo_Quit();
      return;
    }
  }
  beep();
  return;    
}

void SelectDriver() {
  printf("\n\nSelectDriver()\n");
}

void SelectReboot() {
  gringo_Quit();
  caronte_reboot();
  exit(1);
}

void caronte_menu1() {
  TWindow *win1  = NULL;
  TButton *btn1  = NULL;
  TButton *btn2  = NULL;
  TButton *btn3  = NULL;
  
  gringo_Init( NULL, NULL );

  win1 = window_Create( 10, 3, 58, 18, "Scelta della distribuzione" );
  if (distro->count==0) {
    label_Create(  win1,   2,  2,  0, "Per qualche motivo non e' stato possibile montare la" );
    label_Create(  win1,   2,  3,  0, "partizione o il cdrom che contiene la distribuzione da");
    label_Create(  win1,   2,  4,  0, "installare. Per ovviare al problema carica un device");
    label_Create(  win1,   2,  5,  0, "driver se l'hardware non e' stato identificato e");
    label_Create(  win1,   2,  6,  0, "installato in precedenza.");
  } else {
    label_Create(  win1,   2,  2,  0, "Una o piu' distribuzioni da installare sono state" );
    label_Create(  win1,   2,  3,  0, "individuate. Nel caso non vuoi caricare device driver");
    label_Create(  win1,   2,  4,  0, "addizzionali puoi proseguire con il programma");
    label_Create(  win1,   2,  5,  0, "d'installazione.");
    label_Create(  win1,   2,  6,  0, "TIP: usa il tasto TAB per muoverti tra i controlli.");
  }
//  box1 = listbox_Create(  win1, 2, 8, 54, 7);
//  listbox_AddItem( box1, "Scelta della distribuzione" );
//  listbox_AddItem( box1, "" );

  grid1 = grid_Create(  win1, 2, 8, 54, 7 );
  grid_OnClick( grid1, SelectDistro );
  grid_AddColumn( grid1, "Device", 10 );
  grid_AddColumn( grid1, "Filesystem", 32 );
  grid_AddColumn( grid1, "Tipo", 8 );

  for ( pitem=distro->head; pitem!=NULL; pitem=pitem->next) {
    ppart = TPARTITION(pitem->data);
    grid_AddText( grid1, ppart->device, ppart->filesystem, ppart->module, NULL );
  }

  btn1 = button_Create( win1,   3, 16, 15, "Scegli" );
  button_OnClick( btn1, SelectDistro );
  btn2 = button_Create( win1,  21, 16, 15, "Carica driver" );
  button_OnClick( btn2, SelectDriver );
  btn3 = button_Create( win1,  39, 16, 14, "Reboot" );
  button_OnClick( btn3, SelectReboot );

  gringo_Loop();
  gringo_Quit();
}
