#include "config.h"
#include <stdio.h>

#include <badpenguin-chain.h>
#include <badpenguin-fs.h>
#include <badpenguin-hardware.h>

#include "caronte-logo.h"

TChain *eide=NULL;
TChain *scsi=NULL;
TChain *part=NULL;

void caronte_partitions() {
  TChainItem *pitem=NULL;
  TPartition *ppart=NULL;

  caronte_title(NULL);
  printf( "\n");

  // Probe partitions
  printf("- Quering EIDE devices...\n" );
  eide = query_eide_devices(NULL);
  printf("- Quering SCSI devices...\n" );
  scsi = query_scsi_devices(NULL);
  printf("- Quering partition table...\n" );
  part = query_partitions(NULL,eide,scsi);

  // print partitions
  printf( "\n");
  printf( "                       Elenco Partizioni\n\n" );
  printf( " Device      Id  Tipo     Versione                             Dimensione\n" );
  printf( " ==========  ==  =======  ==================================   ==========\n" );

  pitem = part->head;
  while (pitem!=NULL) {
    ppart = TPARTITION(pitem->data);
    printf(
      " %10s  %2X  %7s  %-35s  %10lu\n",
      ppart->device, ppart->type,
      ppart->module, ppart->filesystem,
      ppart->size
    );
    pitem = pitem->next;
  }
  PRESS_ANY_KEY

}
