#include "config.h"
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/wait.h>

#include "caronte.h"
#include "caronte-logo.h"

void caronte_shell() {
  pid_t pid;
  int fd;

  if (debug==1) {
    printf("errore: non posso aprire la shell in modalita' debug!\n");
    PRESS_ANY_KEY;
    return;
  }

  // do  
  printf("- avvio della shell di emergenza su tty2... ");
  fd = open("/dev/tty2", O_RDWR);
  if (fd < 0) {
    printf("errore: non posso aprire la shell su /dev/tty2 !\n");
    return;
  } else if (access(SHELL_PATH,  X_OK))  {
    close(fd);
    printf("errore: non esiste la shell %s !\n", SHELL_PATH );
    return;
  }
  // Fork
  if (!(pid = fork())) {
    dup2(fd, 0);
    dup2(fd, 1);
    dup2(fd, 2);
    close(fd);
#ifdef _AGX_
    setsid();
    if (ioctl(0, TIOCSCTTY, NULL)) {
      printf("errore: non posso impostare il terminale di controllo!\n");
      exit(1);
    }
#endif
    execl(SHELL_PATH, SHELL_PATH, NULL);
    printf("errore: impossibile eseguire la shell = %s !\n", strerror(errno));
    exit(1);
  }
  close(fd);
  printf("fatto\n");
}
